<?php

require_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'PerelinkPluginBaseClass.php';

class PerelinkPluginAdmin extends PerelinkPluginBaseClass
{

    private static $info_url = 'http://1drv.ms/1UbwuCG';
    private $options;

    public function __construct()
    {
        $this->options = PerelinkPlugin::getOptions();
        $this->registerHooks();
    }

    private function registerHooks()
    {
        add_action('admin_init', array($this, 'init'));
        add_action('admin_menu', array($this, 'adminMenu'));
        add_filter('plugin_action_links_' . $this->options->pluginBasename, array($this, 'pluginLinksFilter'), 10, 2);
    }

    public function init()
    {
        if ($this->getPage() == $_GET['page'] && isset($_REQUEST['update'])) {
            PerelinkPlugin::getUpdate()->update();
            wp_redirect($_SERVER['HTTP_REFERER']);
            exit();
        }
    }

    private function getPage()
    {
        return 'perelink_admin';
    }

    public function adminMenu()
    {
        add_options_page('Perelink BiNET Pro', 'Perelink BiNET Pro', 8, 'perelink_admin', array($this, 'adminPage'));
    }

    public function adminPage()
    {
        if (!empty($_POST)) {
            $this->saveOptionsFromPost();
        }
        $this->render('admin', array('options' => $this->options));
    }

    public function pluginLinksFilter($links)
    {
        array_unshift(
                $links, '<a href="options-general.php?page=' . $this->getPage() . '">Параметры</a>'
        );
        if (!PerelinkPlugin::getUpdate()->check()) {
            $links[] = '<a href="options-general.php?page=' . $this->getPage() . '&update" title="Доступна новая версия ' . PerelinkPlugin::getUpdate()->getLastVersion() . '">Обновить</a>';
        }

        return $links;
    }

    public function checkUpdate()
    {

    }

    public function saveOptionsFromPost()
    {
        $post = stripslashes_recursive($_POST);
        $this->options->setOptions($post);
    }

}
