<?php

class PerelinkPluginNotification extends PerelinkPluginBaseClass
{

    public function __construct()
    {
        $this->registerHooks();
    }

    private function registerHooks()
    {
        add_action('admin_notices', array($this, 'showMessages'));
    }

    public function message($message)
    {
        $this->appendMessage(array('message' => $message, 'level' => 'message'));
    }

    private function appendMessage($message)
    {
        $messages = $this->getMessages();
        $messages[] = $message;
        update_option('perelink_messages', json_encode($messages));
    }

    private function getMessages()
    {
        $messages = json_decode(get_option('perelink_messages'), true);
        if (!is_array($messages)) {
            $messages = array();
        }
        return $messages;
    }

    public function warning($message)
    {
        $this->appendMessage(array('message' => $message, 'level' => 'warning'));
    }

    public function showMessages()
    {
        foreach ($this->getMessages() as $message) {
            $this->render('notification_' . $message['level'], array('message' => $message['message']));
        }
        $this->clearMessages();
    }

    public function clearMessages()
    {
        delete_option('perelink_messages');
    }

}
